#define F_CPU 3333333UL

#include <avr/io.h>
#include <stdbool.h>
#include <util/delay.h>

#define LED1 4 // PWM2/PD4
#define LED2 5 // PWM3/PD5
#define LED3 5 // RST3/PC5

#define BTN1 2 // INT2/PC2
#define BTN2 1 // AN2/PD1
#define BTN3 2 // AN3/PD2

int main(void) {
    PORTD.DIRSET = (1 << LED1) | (1 << LED2);
    PORTC.DIRSET = (1 << LED3);

    PORTD.DIRCLR = (1 << BTN2) | (1 << BTN3);
    PORTC.DIRCLR = (1 << BTN1);

    PORTC.PIN2CTRL |= PORT_PULLUPEN_bm;
    PORTD.PIN1CTRL |= PORT_PULLUPEN_bm;
    PORTD.PIN2CTRL |= PORT_PULLUPEN_bm;

    bool button_state_1 = false;
    bool button_state_2 = false;
    bool button_state_3 = false;

    // Turn LEDs off
    PORTD.OUTSET = (1 << LED1);
    PORTD.OUTSET = (1 << LED2);
    PORTC.OUTSET = (1 << LED3);

    while (1) {

        if (!(PORTC.IN & (1 << BTN1))) {
            if (!button_state_1) {

                PORTD.OUTTGL = (1 << LED1);
                button_state_1 = true;
            }
        } else {
            button_state_1 = false;
        }

        if (!(PORTD.IN & (1 << BTN2))) {
            if (!button_state_2) {

                PORTD.OUTTGL = (1 << LED2);
                button_state_2 = true;
            }
        } else {
            button_state_2 = false;
        }

        if (!(PORTD.IN & (1 << BTN3))) {
            if (!button_state_3) {

                PORTC.OUTTGL = (1 << LED3);
                button_state_3 = true;
            }
        } else {
            button_state_3 = false;
        }

        _delay_ms(1);
    }
}
